/* mclean.h  --  header file for image morphology noise reduction program */

/* mclean version 1.0   15 July 1991               */
/* morphological image noise reduction program     */
/*                                                 */ 
/* by Richard Alan Peters II                       */
/* Department of Electrical Engineering            */
/* Vanderbilt University School of Engineering     */ 
/* Nashville, TN 37235                             */ 
/* rap2@vuse.vanderbilt.edu                        */ 
/*                                                 */ 
/* This software is freely redistributable if      */ 
/* the author's name and affiliation are included. */


/* includes */

#include <ctype.h>
#include <math.h>
#include <malloc.h>			
#include <stdio.h>	
#include <string.h>


/* defs */

#define SFMASK	0x0400		/* set / function mask */
#define SET		0x0000		/* set operation */
#define FUNCT	0x0400		/* function operation */

#define IMMASK  0x0200		/* image type bit of MorphOp */
#define	GRAIMG	0x0000		/* gray-level image flag */
#define	BINIMG	0x0200		/* binary image flag */

#define SEMASK	0x0100		/* structuring element (SE) type bit */
#define GRASE	0x0000		/* gray-level SE */
#define BINSE	0x0100		/* binary SE */

#define OPMASK	0x00FF		/* morph operation type bits of MorphOp */
#define LLMASK  0x001F		/* low-level morph ops mask */
#define	ERODE	0x0001		/* erode flag  */
#define	DILATE	0x0002		/* dilate flag */
#define	OPEN	0x0004		/* open flag   */
#define	CLOSE	0x0008		/* close flag  */
#define RANK	0x0010		/* rank filter flag */
#define TOPHAT  0x0020		/* tophat (image minus open ) flag */
#define BOTHAT  0x0040		/* tophat (close minus image) flag */
#define NOTFLG  0x0080      /* "not" flag for binary erodes and dilates */

#define SEPATH	"SEPATH"	/* structuring element directory env. var */

#define AUTO	1		/* make disk SE */
#define PLUS	2		/* use 3 by 3 "+" shaped SE */
#define S3X3	3		/* use 3 by 3 square SE */
#define S5X5	4		/* use 5 by 5 quasi disk SE */

#define BLACK	0
#define WHITE	255
#define TRUE	1
#define FALSE	0
#define ZERO	0
#define NSIZE	256
#define ALLOC	TRUE

#define MIN(a,b) ((a<b)?(a):(b))
#define MAX(a,b) ((a>b)?(a):(b))

/* typedefs */

#ifndef BYTE
typedef unsigned char byte;
#define BYTE 1
#endif

#ifndef WORD
typedef short int word;
#define WORD
#endif

void Skeleton();
