/* tophatspec.h  --  header file for opening spectrum program */

/* tophatspec version 1.0  8 May 1994              */
/*                                                 */ 
/* by Richard Alan Peters II                       */
/* Department of Electrical Engineering            */
/* Vanderbilt University School of Engineering     */ 
/* Nashville, TN 37235                             */ 
/* rap2@vuse.vanderbilt.edu                        */ 
/*                                                 */ 
/* This software is freely redistributable if      */ 
/* the author's name and affiliation are included. */

	

/* includes */

#include <ctype.h>
#include <math.h>
#include <malloc.h>			
#include <stdio.h>	
#include <string.h>


/* defs */


#define SEPATH	"SEPATH"	/* structuring element directory env. var */

#define DISK    1		/* quazi disk-shaped SE family */
#define HORZ    2		/* horizontal line SE family */
#define VERT    3		/* vertical line SE family */
#define SEFL    4		/* SE family is in files */

#define BLACK       0
#define WHITE     255
#define TRUE        1
#define FALSE       0
#define ZERO        0
#define ALLOC    TRUE
#define NUMBANDS  256


#define MIN(a,b) ((a<b)?(a):(b))
#define MAX(a,b) ((a>b)?(a):(b))

/* typedefs */

#ifndef BYTE
typedef unsigned char byte;
#define BYTE 1
#endif

#ifndef WORD
typedef short int word;
#define WORD
#endif

static void GetCLArgs();
static void CheckSEfiles();
static void SubImg();
static char *rindex();
