/* raw2ras */

/* program to convert an ascii array image to a sun rasterfile. */
/* by Richard Alan Peters II  */


#include "stdio.h"
#include "malloc.h"
#include "rasterio.h"



main( argc, argv )
   unsigned int argc;
   char * argv[];
   {
   struct rasterfile *RasHd;
   byte *cmap;
   byte *u,*Img;
   int val;
   int n = argc;
   int X = 512;
   int Y = 512;


   /* check args */

   if ( argc > 1  && argv[1][0] == '?' )
      {
      fprintf(stderr, "usage:  asc2ras <In >Out [-X nnn] [-Y nnn]\n");
      exit(0);
      }


   /* get args */

   while ( --n )
      {
      if ( argv[n][0] == '-' )          /* then this is a switch */
         {
         if ( argv[n][1] == 'X' )  
            X = atoi( argv[n+1] );
         else if ( argv[n][1] == 'Y' )  
            Y = atoi( argv[n+1] );
         else
            {
            fprintf(stderr, "Invalid argument\n");
            fprintf(stderr, "usage:  raw2ras <In >Out [-X nnn] [-Y nnn]\n");
            exit(0);
            }
         }
      }


   /* input raw image */

   if ( !(Img = (byte *)calloc( X*Y, sizeof(byte) )) )
      {
      fprintf(stderr,"Unable to allocate space for input image\n");
      exit(0);
      }

   u = Img;

   while ( !feof(stdin) )
      {
      fscanf( stdin, "%d", &val );
      *(u++) = (byte)val;;
      }


   /* make and write rasterfile */

   RasHd = MakeHeader( X, Y );
   cmap  = MakeColorMap();

   WriteRasterFile( stdout, RasHd, cmap, Img, 0, 0, 0, 0 ); 

   free( RasHd );
   free( cmap  );
   }




 
