/* ras2asc */

/* program to convert a sun rasterfile to an ascii-array image. */
/* by Richard Alan Peters II  */


#include "stdio.h"
#include "malloc.h"
#include "rasterio.h"





main( argc, argv )
   unsigned int argc;
   char * argv[];
   {
   byte *Img;
   byte *cmap;
   struct rasterfile RasHd;	/* raster file header */
   byte *I;
   int n = argc;
   int lgth =0;
   int i,j;
   int r,c;

   /* check args */

   if ( argc > 1  && argv[1][0] == '?' )
      {
      fprintf(stderr, "usage:  ras2asc <In >Out\n");
      exit(0);
      }

   /* read the input image into memory */
   if ( ReadRasterFile( stdin, &RasHd, &cmap, &Img, 0, 0, 0, 0, ALLOC ) ) 
      exit(0);

   /* extract the luminance */
   ExtractLuminance( &RasHd, cmap, Img, 0, 0, 0, 0 );

   /* get image dimensions */
   c = RasHd.ras_width;
   r = RasHd.ras_height;

   /* write out ascii image */  

   I = Img;
   for ( j=r; j; --j )
      {
      for ( i=c; i; --i )
         {
         printf("%4u ",*I);
         ++I;
         }
      printf("\n");
      }

   }




 
